
/* area.cc */

#include <string>
#include <cassert>

#include "area.hpp"
#include "area.ipp"

/* ---------------------------------------------------------------------- */

void Area::initialize ()
{
   setRect (0, 0, 100, 100);
   setFlag (QGraphicsItem::ItemIsMovable);
   setFlag (QGraphicsItem::ItemIsSelectable);
   // setPen (QPen (Qt::blue));
   // setBrush (QBrush (Qt::yellow));
}

void Area::initializeTopLevel ()
{
  setPen (QPen (Qt::NoPen));
  setBrush (QBrush (Qt::NoBrush));
  setFlags (0);
}

void Area::connected ()
{
    Area * above = getAboveArea ();
    if (above != NULL)
    {
       setParentItem (above);

       /*
       Source * source = getFirstSource ();
       while (source != NULL)
       {
          source->connected ();
          source = source->getNextSource ();
       }

       Target * target = getFirstTarget ();
       while (target != NULL)
       {
          target->connected ();
          target = target->getNextSource ();
       }
       */
    }
}

void Area::disconnected ()
{
    // scene = NULL;
    // setScene (scene);
}

/* ---------------------------------------------------------------------- */

void Source::initialize ()
{
   setRect (0, 0, 10, 10);
   setPen (QPen (Qt::red));
   setBrush (QBrush (Qt::green));
}

void Source::connected ()
{
   setParentItem (getArea ());
}

void Source::disconnected ()
{
}

/* ---------------------------------------------------------------------- */

void Target::initialize ()
{
   setRect (0, 0, 10, 10);
   setPen (QPen (Qt::red));
   setBrush (QBrush (Qt::yellow));
}

void Target::connected ()
{
   setParentItem (getArea ());
}

void Target::disconnected ()
{
}

/* ---------------------------------------------------------------------- */

void Connection::connected ()
{
}

void Connection::disconnected ()
{
}

/* ---------------------------------------------------------------------- */


