
/* area.t */

module data;

/* ---------------------------------------------------------------------- */

idecl
{
   #include <QGraphicsScene>
   #include <QGraphicsItemGroup>
   #include <QGraphicsRectItem>
   #include <QGraphicsLineItem>
}

decl
{
}

/* ---------------------------------------------------------------------- */

class Area : public QGraphicsRectItem
{
   list <Area> Items
   {
      Suffix1 = Item;
      Suffix2 = Items;
      Up = aboveArea;
      insert_notification = connected; // notify item
      remove_notification = disconnected;
   }

   list <Source> Sources
   {
      Suffix1 = Source;
      Suffix2 = Sources;
      Up = area;
      insert_notification = connected;
      remove_notification = disconnected;
   }

   list <Target> Targets
   {
      Suffix1 = Target;
      Suffix2 = Targets;
      Up = area;
      insert_notification = connected; // notify item
      remove_notification = disconnected;
   }

   decl
   {
      public:
         QGraphicsScene * scene;
         // QGraphicsItemGroup * group;

      private:
         void initialize ();

         void connected ();
         void disconnected ();

      public:
         void addArea (Area * a) { insertLastItem (a); }
         void addSource (Source * s) { insertLastSource (s); }
         void addTarget (Target * t) { insertLastTarget (t); }
         void initializeTopLevel ();
   }

   init
   {
       initialize ();
   }
};

/* ---------------------------------------------------------------------- */

class Source : public QGraphicsRectItem
{
   list <Connection> Connections
   {
      Suffix1 = Connection;
      Suffix2 = Connections;
      Up = source;
      insert_notification = connected; // notify item
      remove_notification = disconnected;
   }

   decl
   {
      private:
         void initialize ();
         void connected ();
         void disconnected ();
   }

   init
   {
       initialize ();
   }
};

class Target : public QGraphicsRectItem
{
   decl
   {
      private:
         void initialize ();
         void connected ();
         void disconnected ();
   }

   init
   {
       initialize ();
   }
};

class Connection : public QGraphicsLineItem
{
   attr < Target * > target;

   decl
   {
      void setSource (Source * src) { src->insertLastConnection (this); }
   }

   decl
   {
      private:
         void connected ();
         void disconnected ();
   }
};

/* ---------------------------------------------------------------------- */


