
/* kview.t */

project "kview";

/* make */

make
{
   // automake = true;
   // autoinit = true;
   autoclean = true;
   debug = true;
   kdevelop = true;

   // #define STANDALONE

   #ifdef STANDALONE
   program "kview"
   {
      t_cc_source "area.cc" { Standalone = true; }
      cc_source "tree.cc";
      cc_source "prop.cc";
      cc_source "view.cc";

      cc_source "document.cc";
      moc_rule  "document";

      // cc_source "module.cc";
      // moc_rule  "module";

      cc_source "main.cc";
   }
   #endif

   #ifndef STANDALONE
   library "kview"
   {
      t_cc_source "area.cc" { Standalone = true; }
      cc_source "tree.cc";
      cc_source "prop.cc";
      cc_source "view.cc";
      cc_source "document.cc";
      moc_rule  "document";
      cc_source "module.cc";
      moc_rule  "module";

      // cxxflags "-Wl,--no-undefined";
   }

   // files added to kdevelop project
   user_file "kview.desktop";
   user_file "kview.rc";

   /* RUN */

   rule "run: all install";
   rule_tab "./start";
   rule "";

   /* INSTALL */

   defn "PLUGIN = kview";

   defn "MIME_PACKAGE = package-x-kview.xml";
   defn "MIME_DIR = text"; // only for uninstall
   defn "MIME_FILE = x-kview.xml"; // only for uninstall

   install_kdevelop "lib/kde4/$(PLUGIN).so" { exec=true; }
   install_kdevelop "share/kde4/services/$(PLUGIN).desktop";
   install_kdevelop "share/apps/$(PLUGIN)/$(PLUGIN).rc";

   install_kdevelop "share/mime/packages/$(MIME_PACKAGE)";
   uninstall_kdevelop "share/mime/$(MIME_DIR)/$(MIME_FILE)";
   mime_kdevelop;

   #endif

   /* Qt, KDE, KDevelop */

   // ldflags "-L /usr/lib/kde4/devel"; // !? - Fedora 14 - before /usr/lib (which contains kde3 libraries)

   lib_qt;
   lib_kde;
   lib_kdevelop;

   /* Qt Property Browser */

   defn "QT_PROP = /opt/qtpropertybrowser-2.5.1";

   cxxflags "-I $(QT_PROP)/include";

   ldflags "-lQtSolutions_PropertyBrowser-2.5";
   ldflags "-L $(QT_PROP)/lib";
   rpath "$(QT_PROP)/lib";

   /* libraries */

   #if 1
   ldflags "-lkdecore";
   ldflags "-lkdeui";
   // ldflags "-lkio";
   // ldflags "-lknotifyconfig";
   // ldflags "-lthreadweaver";
   // ldflags "-lktexteditor";
   ldflags "-lkdevplatforminterfaces";
   // ldflags "-lkdevplatformlanguage";
   // ldflags "-lkdevplatformutil";
   // ldflags "-lkdevplatformoutputview";
   ldflags "-lsublime";
   #endif
}
