
/* view.cc */

#include "view.h"

#include "QtGui"

MyView::MyView (MyPlugin *plugin, QWidget* parent)
  : QGraphicsView (parent)
{
  scene = new QGraphicsScene;
  scene->setSceneRect (0, 0, 800, 600);
  this->setScene (scene);

  // scene->addText ("Hello, world!");
  // scene->addRect (1, 1, 100, 80, QPen (Qt::red), QBrush (Qt::lightGray));

  /* background */

  const int n = 16;
  QBitmap texture (n, n);
  texture.clear ();

  QPainter painter (& texture);
  painter.drawLine (0, 0, n-1, 0);
  painter.drawLine (0, 0, 0, n-1);

  QBrush brush (QColor ("cornflowerblue"));
  brush.setTexture (texture);
  scene->setBackgroundBrush (brush);

  /* plane */

  plane = new Area;
  plane->initializeTopLevel ();
  plane->setRect (10, 10, 630, 470);
  scene->addItem (plane);
}

void MyView::addArea (Area * a)
{
   plane->addArea (a);
}

void MyView::example ()
{
    Area * a = new Area;
    a->setPen (QPen (Qt::green));
    a->setBrush (Qt::yellow);
    a->setPos (10, 10);
    a->setToolTip ("Acko");

    Source * a_src = new Source;
    a_src->setPos (90, 0);
    a->addSource (a_src);

    Target * a_target = new Target;
    a->addTarget (a_target);

    Area * b = new Area;
    b->setPen (QPen (Qt::red));
    b->setBrush (QColor ("cornflowerblue"));
    b->setToolTip ("Bee");
    b->setPos (320, 10);

    Target * b_target = new Target;
    b->addTarget (b_target);

    Source * b_source = new Source;
    b_source->setPos (90, 0);
    b->addSource (b_source);

    Connection * c = new Connection;
    c->setSource (a_src);
    c->setTarget (b_target);

    Area * s = new Area;
    s->setPen (QPen (Qt::red));
    s->setBrush (QColor ("orange"));
    s->setToolTip ("Subitem");
    s->setRect (10, 10, 80, 20);
    a->addArea (s);

    Area * t = new Area;
    t->setPen (QPen (Qt::red));
    t->setBrush (QColor ("orange"));
    t->setToolTip ("Subitem 2");
    t->setRect (10, 10, 80, 20);
    b->addArea (t);

    this->addArea (a);
    this->addArea (b);
    this->centerOn (a);
}